export function lockRange (value, nrOfBits) {
  const lowerValue = 0
  const upperValue = Math.pow(2, nrOfBits) - 1
  if (value < lowerValue) {
    return lowerValue
  } else if (value > upperValue) {
    return lowerValue
  } else {
    return value
  }
}

const prefixMap = {
  'y': 1e-24,
  'z': 1e-21,
  'a': 1e-18,
  'f': 1e-15,
  'p': 1e-12,
  'n': 1e-9,
  'u': 1e-6,
  'm': 1e-3,
  'k': 1e3,
  'M': 1e6,
  'G': 1e9,
  'T': 1e12,
  'P': 1e15,
  'E': 1e18,
  'Z': 1e21,
  'Y': 1e24
}
const REGEX_ENG = /^([+-])?\s*(\d*\.?\d+|\d+\.?\d*)?([yzafpnumkMGTPTEZY]|e[+-]?\d+)?$/

export function printEng (number) {
  const base = Math.floor(Math.floor(Math.log10(Math.fabs(number)) / 3))
  return base
}

export function parseEng (string) {
  const match = string.match(REGEX_ENG)
  if (!match) {
    return null
  }
  let num = 0
  let sign = 1
  let exp = 0
  if (match[1] === '-') {
    sign = -1
  }
  num = parseFloat(match[2])
  if (match[3] && match[3].length > 1) {
    exp = parseInt(match[3].substring(1))
  } else if (match[3]) {
    exp = prefixMap[match[3]]
  }
  return sign * num * Math.pow(10, exp)
}
