import React from 'react'
import EditProject from './EditProject'
import ProjectList from './ProjectList'
import { projectList } from '../initialData'

class Project extends React.Component {
  render () {
    // Retrieve the projectId from the URL
    const { projectId } = this.props.params
    let project
    if (typeof projectId !== 'undefined') {
      // It the projectId is defined, check whether there's such a project
      project = projectList.find(project => { return (project.id === projectId) })
    } else if (projectList.length > 0) {
      this.props.router.transitionTo(`/project/${projectList[0].id}`)
    }

    return (
      <div className='app-main'>
        <div className='app-content'>
          <EditProject project={project} actions={this.props.projectActions} />
        </div>
        <div className='app-aside-left'>
          <p>New Project Button</p>
          <p>Project List</p>
          <ProjectList projectList={projectList} />
        </div>
      </div>
    )
  }
}

export default Project
